unit UALmFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type

  TfrmALm = class(TForm)
    imgInfo: TImage;
    lblMsg: TLabel;
    lblIcon: TLabel;
    labTime: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure imgInfoClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
     Bmp: TBitmap;
     InTimer: Integer; //Ψӭp ɶ۹m
     InValue: Integer;
     InDraw: Boolean;
     tmFadeIn: TTimer;  //i
     tmFadeOut: TTimer; //X
     tmDelay: TTimer;   //X{ɶ
     StartColor, EndColor: TColor;
    procedure tmFadeInTimer(Sender: TObject);
    procedure tmDelayTimer(Sender: TObject);
    procedure tmFadeOutTimer(Sender: TObject);
    function CalcRect(MaxWidth: Integer; const ACap: string; AData: Pointer):
      TRect;
    procedure WMEraseBkgnd(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure DrawBk;
    procedure CreateTimers;
    procedure SerFrmKind ; //]weܻPˤl
  public
    { Public declarations }
  end;

  function startALM(Mainitem,Recs,Times,isImpot : String):Boolean;
var
//  Form2: TForm2;
  isIPM : Boolean = false;
  InfoStartColor: TColor = clWhite;
  {* e_lCAw]ȬզAϥΪ̥iק}
  InfoEndColor: TColor = $00F0E080;
  {* eCAw]ȬLŦAϥΪ̥iק}
  IPMStartColor: TColor = clWhite;
  {* ~e_lCAw]ȬզAϥΪ̥iק}
  IPMEndColor: TColor = $008080F0;
  {* ~e_lCAw]ȬLAϥΪ̥iק}
implementation
{$R *.dfm}
  var ThisList: TThreadList;
  function GetWorkRect: TRect;
  begin
        //^Windows jp ex 1027 x 768 bottem := 768 Left := 1024
        //]wάdߨtΪѼ  //RESULT fEELbACK
    SystemParametersInfo(SPI_GETWORKAREA, 0, @Result, 0)
  end;

  procedure CleanUp;
  var
    iLoop: Integer;
  begin
    for iLoop := ThisList.LockList.Count - 1 downto 0 do
      TForm(ThisList.LockList.Items[iLoop]).Free;
  end;

  function startALM(Mainitem,Recs,Times,isImpot : String):Boolean;
  var
    H: Integer;
    str : string ;
  begin
    with TfrmALm.Create(nil) do
    begin
      SerFrmKind ;
      isIPM := (isImpot ='Y' );

      str := Mainitem+#13+Recs;
      lblMsg.Caption := Str ;
      labTime.Caption := Times ;

      H := CalcRect(lblMsg.Width, str, nil).Bottom - lblMsg.Height;
      if H > 0 then
      begin
        lblMsg.Height := lblMsg.Height + H;
        Height := Height + H;
      end;
      ShowWindow(Handle, SW_SHOWNOACTIVATE);
      SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or
        SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOOWNERZORDER); // eܦbȥ\C᭱
      FormShow(nil);
    end;

  end ;

{ TForm2 }

function TfrmALm.CalcRect(MaxWidth: Integer; const ACap: string;
  AData: Pointer): TRect;
begin
  // ]nWɩҥHn_Tr
  Result := Rect(0, 0, MaxWidth, 0);
  DrawText(lblMsg.Canvas.Handle, PChar(ACap), -1, Result, DT_CALCRECT or DT_LEFT
    or DT_WORDBREAK or DT_NOPREFIX or DrawTextBiDiModeFlagsReadingOnly);
end;

procedure TfrmALm.DrawBk;
type
  PRGBArray = ^TRGBArray;
  TRGBArray = array[Byte] of TRGBTriple;
var
  PLine: PRGBArray;
  x, y: Integer;
  ARect: TRect;
  RowInc: Integer;
  sr, sg, sb, er, eg, eb: Integer;
begin
  if InDraw then Exit;
  InDraw := True;
  Bmp.Width := ClientWidth;
  Bmp.Height := ClientHeight;
  sr := GetRValue(StartColor);
  sg := GetGValue(StartColor);
  sb := GetBValue(StartColor);
  er := GetRValue(EndColor);
  eg := GetGValue(EndColor);
  eb := GetBValue(EndColor);
  PLine := PRGBArray(Bmp.ScanLine[0]);
  for x := 0 to Bmp.Width - 1 do
  begin
    PLine[x].rgbtRed := sr + (er - sr) * x div Bmp.Width;
    PLine[x].rgbtGreen := sg + (eg - sg) * x div Bmp.Width;
    PLine[x].rgbtBlue := sb + (eb - sb) * x div Bmp.Width;
  end;
  RowInc := (Bmp.Width * 3 + 3) div 4 * 4;
  for y := 1 to Bmp.Height - 1 do
    Move(PLine^, Bmp.ScanLine[y]^, RowInc);
  ARect := Rect(0, 0, Width, Height);
  Frame3D(Bmp.Canvas, ARect, $777777, $777777, 1);
  InDraw := False;
  Refresh;
end;

procedure TfrmALm.WMEraseBkgnd(var Msg: TWMEraseBkgnd);
begin
  Bitblt(Msg.DC, 0, 0, ClientWidth, ClientHeight, Bmp.Canvas.Handle, 0, 0,
    SRCCOPY);
  Msg.Result := 1; // wBz
end;

procedure TfrmALm.FormCreate(Sender: TObject);
begin
  Left := -300;
  Top := Screen.Height + 300;
  with ThisList.LockList do
  try
    Add(Self);
  finally
    ThisList.UnlockList;
  end;
  Bmp := TBitmap.Create;
  Bmp.PixelFormat := pf24Bit;
  CreateTimers;
  tmFadeIn.Enabled := True; //}liF
end;

procedure TfrmALm.CreateTimers;
begin
  tmFadeIn := TTimer.Create(Self);
  with tmFadeIn do
  begin
    Enabled := False;
    Interval := 15;
    OnTimer := tmFadeInTimer;
  end;
  tmFadeOut := TTimer.Create(Self);
  with tmFadeOut do
  begin
    Enabled := False;
    Interval := 15;
    OnTimer := tmFadeOutTimer;
  end;
  tmDelay := TTimer.Create(Self);
  with tmDelay do
  begin
    Enabled := False;
    Interval := 5000;
    OnTimer := tmDelayTimer;
  end;
end;

procedure TfrmALm.tmDelayTimer(Sender: TObject);
begin
  tmFadeIn.Enabled := False;
  tmDelay.Enabled := False;
  tmFadeOut.Enabled := True;
end;

procedure TfrmALm.tmFadeInTimer(Sender: TObject);
begin
  Inc(InTimer);
  InValue := 1 + InTimer * 3 div 11;

  if Top + Height <= GetWorkRect.Bottom then
  begin
    tmFadeIn.Enabled := False;
    tmDelay.Enabled := True;
  end
  else if Top + Height + InValue <= GetWorkRect.Bottom then
    Top := GetWorkRect.Bottom - Height
  else
    Top := Top - InValue;
end;

procedure TfrmALm.tmFadeOutTimer(Sender: TObject);
begin
  if InTimer > 0 then
    Dec(InTimer);
  InValue := 1 + InTimer * 3 div 11;
  Top := Top + InValue;
  if Top >= GetWorkRect.Bottom - 2 then
  begin
    tmFadeOut.Enabled := False;
    Close;
  end;
end;

procedure TfrmALm.SerFrmKind;
begin
  imgInfo.Visible := True;
  lblIcon.Caption := '';
  if not isIPM then
  begin
    StartColor := ColorToRGB(InfoStartColor);
    EndColor := ColorToRGB(InfoEndColor);
  end else
  begin
    StartColor := ColorToRGB(IPMStartColor);
    EndColor := ColorToRGB(IPMEndColor);
  end ;
end;

procedure TfrmALm.FormDestroy(Sender: TObject);
begin
  Bmp.Free;
  with ThisList.LockList do
  try
    Delete(IndexOf(Self));
  finally
    ThisList.UnlockList;
  end;
end;

procedure TfrmALm.FormShow(Sender: TObject);
begin
  Top := GetWorkRect.Bottom - 1;  //ѥkU X{ @}lOb iHU
  Left := GetWorkRect.Right - Width;
  tmDelay.Interval := 5 * 1000;
  DrawBk;
end;

procedure TfrmALm.imgInfoClick(Sender: TObject);
begin
  //Close ;
tmDelayTimer(Sender);
end;

procedure TfrmALm.FormClick(Sender: TObject);
begin
//  Close;
  tmDelayTimer(Sender);
end;

procedure TfrmALm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tmFadeIn.Enabled := False;
  tmDelay.Enabled := False;
  tmFadeOut.Enabled := False;
  Action := caFree; // 
end;

initialization
  ThisList := TThreadList.Create;

finalization
  CleanUp;
  FreeAndNil(ThisList);
end.
