unit UserverFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,registry;

type
  TDateServerFrm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SetDataBaseDir ;
  public
    { Public declarations }
    DataDir : string ;
    DataToClient :integer ;
  end;

var
  DateServerFrm: TDateServerFrm;

implementation

uses UDataMoudle;

{$R *.DFM}

procedure TDateServerFrm.Button1Click(Sender: TObject);
begin
  SetDataBaseDir;
end;

procedure TDateServerFrm.SetDataBaseDir;
var
 regDir ,Dir : string ;
begin
  Dir := GetCurrentDir ;

  with TRegistry.Create do
  begin
     try
        RootKey := HKEY_CURRENT_USER;
        if KeyExists('\Software\DateReport') then
        begin
           if OpenKey('\Software\DateReport',True) then
           begin
            regDir := ReadString('DataBaseDir');
            regDir := UpperCase(regDir);
            Dir    := UpperCase(Dir);
            if CompareText(regDir,Dir) <> 0 then
            begin
              if OpenKey('\Software\DateReport',True) then
                 WriteString('DataBaseDir',Dir);
            end ;
           end ;
        end else
        begin
          if CreateKey('\Software\DateReport') then
             if OpenKey('\Software\DateReport',True) then
                 WriteString('DataBaseDir',Dir);
        end ;
     finally
       CloseKey;
       Free;
     end;
  end;
  Label2.Caption := 'Ʈw| G'+Dir;
end;

procedure TDateServerFrm.FormCreate(Sender: TObject);
begin
  DataToClient := 0 ;
end;

end.
