unit UselectTime;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TfrmSelTime = class(TForm)
    Label3: TLabel;
    chKHour: TComboBox;
    Label5: TLabel;
    chkMin: TComboBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Bevel1: TBevel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure chKHourKeyPress(Sender: TObject; var Key: Char);
    procedure chkMinKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function SelecTimes(typ: integer ;ordStr : String) : String ;

var
  frmSelTime: TfrmSelTime;

implementation
uses UMainForm;

{$R *.dfm}

{ TForm3 }

function SelecTimes(typ: integer;ordStr : String ) : String;
var
 i : integer ;
 str : string ;
begin
  with TfrmSelTime.Create(Application) do
  begin
    try
      Result := ordstr ;
      chkMin.Items.Clear ;
      case typ of
       0 :begin
            chkMin.Items.Add('00');
            chkMin.Items.Add('30');
          end ;
       1 :begin

            for i := 0 to 59 do
            begin
              str := inttostr(i);
              DatePocke.FillStr(str,1);
              chkMin.Items.Add(str);
            end;
          end ;
      end;
      chKHour.Text := copy(ordstr,1,2);
      chkMin.Text := copy(ordstr,3,2);
      if ShowModal = mrOk then
      begin
        Result := chKHour.Text + chkMin.Text ;
      end ;
    finally
      Free ;
    end;

  end;

end;

procedure TfrmSelTime.SpeedButton1Click(Sender: TObject);
begin
   ModalResult := mrOK	 ;
end;

procedure TfrmSelTime.SpeedButton2Click(Sender: TObject);
begin
   ModalResult := mrNO	 ;
end;
procedure TfrmSelTime.chKHourKeyPress(Sender: TObject; var Key: Char);
begin
 if key =#13 then chkMin.SetFocus ;
end;

procedure TfrmSelTime.chkMinKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then ModalResult := mrOK;
end;

procedure TfrmSelTime.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
   VK_ESCAPE	 : ModalResult := mrNO	 ;
  end;

end;

initialization
  IsLibrary := True;
end.
