unit uAddDataFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons, ToolWin, ExtCtrls,UselectTime;

type
  TinsertData = class(TForm)
    Panel1: TPanel;
    DateTime: TDateTimePicker;
    edtMainCode: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    ediTime: TEdit;
    Label3: TLabel;
    Label5: TLabel;
    edtStartAlrm: TEdit;
    edtEndAlrm: TEdit;
    Panel2: TPanel;
    memoReco: TMemo;
    chkisImpot: TCheckBox;
    Label6: TLabel;
    Panel3: TPanel;
    btnClose: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    stCaption: TStaticText;
    procedure ediTimeClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure edtEndAlrmExit(Sender: TObject);
    procedure edtMainCodeExit(Sender: TObject);
    procedure edtMainCodeKeyPress(Sender: TObject; var Key: Char);
    procedure edtStartAlrmKeyPress(Sender: TObject; var Key: Char);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
    procedure DoGetTimeForm(sender:TObject);
  public
    { Public declarations }
  end;

  function MakeData(var DataTimes :TDateTime;
                    var Times,startAlrm,EndAlrm: String; //ɶ,}lĵi,פĵi
                    var mainCdoe, //D
                        Recor,isImpot:string;
                    ty : integer) : Boolean ; //

var
  insertData: TinsertData;

implementation


{$R *.dfm}
function MakeData(var DataTimes :TDateTime;
                  var Times,startAlrm,EndAlrm: string; //ɶ,}lĵi,פĵi
                  var mainCdoe, //D
                      Recor,isImpot:string;
                  ty :integer ) : Boolean ; //
begin

  with TinsertData.Create(Application) do
  begin
    try

       DateTime.DateTime := DataTimes ; //
       DateTime.Enabled := ty = 0 ;
       if ty = 0 then  begin
         stCaption.Caption := 'sW' ;
         ActiveControl := DateTime ;
       end
       else begin
         stCaption.Caption := 'ק' ;
         ActiveControl := edtMainCode ;
       end ;
       ediTime.Text  := Times;      //ɶ
       edtMainCode.Text  := mainCdoe ;  //D
       memoReco.Lines.text := Recor ;      //
       edtStartAlrm.Text := startAlrm; // _lĵiɶ
       edtEndAlrm.Text   := EndAlrm;   // פĵiɶ
       chkisImpot.Checked := isImpot = 'Y' ;



       Result := ShowModal = MrYes ;
       if Result then
       begin
         DataTimes :=  DateTime.DateTime ;    //
         Times     := ediTime.Text;      //ɶ
         mainCdoe  := edtMainCode.Text ;     //D
         Recor     := memoReco.Lines.Text ;  //
         startAlrm := edtStartAlrm.Text;    // _lĵiɶ
         EndAlrm   := edtEndAlrm.Text;     // פĵiɶ
         if chkisImpot.Checked then isImpot := 'Y'
         else isImpot :='N' ;
       end ;

    finally
      Free;
    end;

  end;

end ;

{ TForm2 }

procedure TinsertData.ediTimeClick(Sender: TObject);
begin
  DoGetTimeForm(sender);
//  (sender as Tedit).Text := SelecTimes((sender as Tedit).tag,(sender as Tedit).Text) ;
end;

procedure TinsertData.SpeedButton1Click(Sender: TObject);
begin
  ModalResult := mrYes ;
end;

procedure TinsertData.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrNo ;
end;

procedure TinsertData.edtEndAlrmExit(Sender: TObject);
var
 strat,ends : integer ;
begin
 strat := strtointdef(edtStartAlrm.text,0) ;
 ends :=  strtointdef(edtEndAlrm.text,-1) ;
 if strat > ends then
 begin
   MessageDlg('ɶp}ɮɶ Xk!!',mtWarning,[mbYes],0);
   edtEndAlrm.setFocus;
 end ;
end;

procedure TinsertData.edtMainCodeExit(Sender: TObject);
begin
  if edtMainCode.Text <> '' then memoReco.SetFocus
  else
  begin
    ShowMessage('SqwD!!') ;
    edtMainCode.SetFocus ;
  end ;
end;

procedure TinsertData.edtMainCodeKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then SelectNext(memoReco,false,false);
end;

procedure TinsertData.DoGetTimeForm(sender: TObject);
begin
(sender as Tedit).Text := SelecTimes((sender as Tedit).tag,(sender as Tedit).Text) ;
end;

procedure TinsertData.edtStartAlrmKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    DoGetTimeForm(sender);
end;


procedure TinsertData.btnCloseClick(Sender: TObject);
begin
  ModalResult := mrNo ;
end;

end.
